import React, { Component, PropTypes } from 'react';

var Interpolate = function (_Component) {
  babelHelpers.inherits(Interpolate, _Component);

  function Interpolate(props, context) {
    babelHelpers.classCallCheck(this, Interpolate);

    var _this = babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Interpolate).call(this, props, context));

    _this.i18n = context.i18n;
    _this.t = context.t;
    return _this;
  }

  babelHelpers.createClass(Interpolate, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var parent = this.props.parent || 'span';
      var REGEXP = this.props.regexp || this.i18n.services.interpolator.regexp;

      var tOpts = babelHelpers.extends({}, this.props.options, { interpolation: { prefix: '#$?', suffix: '?$#' } });
      var format = this.t(this.props.i18nKey, tOpts);

      if (!format || typeof format !== 'string') return React.createElement('noscript', null);;

      var children = [];

      format.split(REGEXP).reduce(function (memo, match, index) {
        var child;

        if (index % 2 === 0) {
          if (match.length === 0) return memo;
          child = match;
        } else {
          child = _this2.props[match];
        }

        memo.push(child);
        return memo;
      }, children);

      return React.createElement.apply(this, [parent, this.props].concat(children));
    }
  }]);
  return Interpolate;
}(Component);

Interpolate.contextTypes = {
  i18n: PropTypes.object.isRequired,
  t: PropTypes.func.isRequired
};

export default Interpolate;