import React, { Component, PropTypes } from 'react';

function getDisplayName(component) {
  return component.displayName || component.name || 'Component';
}

function translate(namespaces) {
  return function Wrapper(WrappedComponent) {
    var t = undefined,
        i18n = undefined;

    var Translate = function (_Component) {
      babelHelpers.inherits(Translate, _Component);

      function Translate(props, context) {
        babelHelpers.classCallCheck(this, Translate);

        var _this = babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Translate).call(this, props, context));

        i18n = context.i18n;

        _this.state = {
          i18nLoadedAt: null
        };
        return _this;
      }

      babelHelpers.createClass(Translate, [{
        key: 'getChildContext',
        value: function getChildContext() {
          return { t: t };
        }
      }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
          this.mounted = true;
          i18n.loadNamespaces(namespaces);
          t = i18n.getFixedT(null, namespaces);
        }
      }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
          var _this2 = this;

          this.onI18nChanged = function () {
            if (!_this2.mounted) return;

            _this2.setState({ i18nLoadedAt: new Date() });
          };

          i18n.on('languageChanged loaded', this.onI18nChanged);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.mounted = false;
          if (this.onI18nChanged) {
            i18n.off('languageChanged', this.onI18nChanged);
            i18n.off('loaded', this.onI18nChanged);
          }
        }
      }, {
        key: 'onI18nChange',
        value: function onI18nChange() {
          if (!this.mounted) return;

          this.setState({ i18nLoadedAt: new Date() });
        }
      }, {
        key: 'render',
        value: function render() {
          var i18nLoadedAt = this.state.i18nLoadedAt;

          return React.createElement(WrappedComponent, babelHelpers.extends({}, this.props, { t: t, i18nLoadedAt: i18nLoadedAt }));
        }
      }]);
      return Translate;
    }(Component);

    Translate.WrappedComponent = WrappedComponent;

    Translate.contextTypes = {
      i18n: PropTypes.object.isRequired
    };

    Translate.childContextTypes = {
      t: PropTypes.func.isRequired
    };

    Translate.displayName = 'Translate[' + getDisplayName(WrappedComponent) + ']';

    return Translate;
  };
}

export default translate;